% DBMM Contest 2013                                  
% MICC - University of Florence                             
%                                                    
% Authors: Lorenzo Seidenari, Lamberto Ballan
%------------------------------------------------------------

clear; close all;run('vlfeat-0.9.17/toolbox/vl_setup');

dataset_dir = 'dataset';

%query_file = 'query/heineken_logo.png';
%query_file = 'query/starbucks_logo.png';
query_file = 'query/marlboro_logo.png';
%query_file = 'query/cocacola_logo.png';

heineken_gt = false(1,110); heineken_gt(26:55)=true;
starbucks_gt = false(1,110); starbucks_gt(71:100)=true;
marlboro_gt = false(1,110); marlboro_gt(56:61)=true; marlboro_gt(101:110)=true;
cocacola_gt = false(1,110); cocacola_gt(19:25)=true;

gt=marlboro_gt;
%test_file = 'dataset/46.png'; %heineken
%test_file = 'dataset/6.png'; %apple

Iq = single(rgb2gray(imread(query_file)));
maxImSize=400;
Iq=resize_image(Iq,maxImSize);
num=zeros(1,110);
show = true; %show detected keypoints and matches. Set to false to speed up.

%use
% >matlabpool open NUM_CORES
% parfor instead of for to execute on multiple cores in parallel
for k=1:110;
    test_file = [dataset_dir '/' num2str(k) '.png'];

    tic;

    Itest=imread(test_file);
    if ndims(Itest) == 3
        Itest=single(rgb2gray(Itest));
    else
        Itest=single(Itest);
    end
    
    %resize image to have the longest side equal to maxImSize, preserving
    %proportions.
    Itest=resize_image(Itest,maxImSize);


    %Several options are available here. This is Difference of Gaussian
    %detector with orientation and scale estimation and SIFT descriptor.
    %type help vl_covdet to see all options.
    [frames_query,sift_query] = vl_covdet(Iq,'Method','DoG','EstimateOrientation',true,'DoubleImage',false);
    [frames_test,sift_test] = vl_covdet(Itest,'Method','DoG','EstimateOrientation',true,'DoubleImage',false);
    threshold=1.5; %D2/D1, i.e. the ratio between the second and first nearest neighbors distances (Lowe IJCV 2004)

    [matches,score] = vl_ubcmatch(sift_query,sift_test,threshold);

    loc1 = frames_query(1:2,:)';
    loc2 = frames_test(1:2,:)';
    % Create a new image showing the two images side by side.
   
    if(show)
        im3 = appendimages(uint8(Iq),uint8(Itest));
        close all;
        % Show a figure with lines joining the accepted matches.
        figure('Position', [100 100 size(im3,2) size(im3,1)]);
        %colormap('gray');
        imshow(im3);
        hold on;
        cols1 = size(Iq,2);

        for i = 1:size(matches,2)

            %each line and point of the same color  
            line([loc1(matches(1,i),1) loc2(matches(2,i),1)+cols1], ...
                 [loc1(matches(1,i),2) loc2(matches(2,i),2)], 'Color', 'c');
        end
        vl_plotframe(frames_query(:,matches(1,:)));
        vl_plotframe(frames_test(:,matches(2,:))+repmat([cols1 0 0 0 0 0]',1,size(matches,2)))

        hold off;
        pause;
    end
    num(k) = length(score); %number of matches
    toc;
end

%example of AP computation using number of matches as a similarity score. 
[ap,rec,prec]=computeAP(num,gt,1,0,true);
